/*
 * Constants.java - constants for the VolanoChat membership servlets.
 */

/**
 * This interface provides constants for the sample VolanoChat
 * membership database servlets.
 *
 * @version 1.0
 * @author  John Neffenger
 */
public interface Constants {
    // HTTP request parameter names.
    String NAME_PARAMETER = "name";
    String PASSWORD_PARAMETER = "password";

    // Host name of database server and database name.
    String DATABASE_HOST = "localhost";
    String DATABASE_NAME = "website";
    String JDBC_DRIVER = "org.gjt.mm.mysql.Driver";
    String JDBC_URL = "jdbc:mysql://" + DATABASE_HOST + "/" + DATABASE_NAME;

    // Database table name and field names.
    String TABLE = "members";
    String NAME_FIELD = "member_name";
    String PASSWORD_FIELD = "member_password";
    String PROFILE_FIELD = "member_profile";
    String LINK_FIELD = "member_link";

    // HTTP response content type and output.
    String CONTENT_TYPE = "text/plain";
    String TRUE = "true";
    String FALSE = "false";
    String ERROR = "error";

    // Default member document link when undefined.
    String DEFAULT_MEMBER_DOCUMENT = "";

    // SQL query statements.
    int NAME_INDEX = 1;
    String ACCESS_QUERY =
        "SELECT "
            + PASSWORD_FIELD
            + ", "
            + PROFILE_FIELD
            + ", "
            + LINK_FIELD
            + " FROM "
            + TABLE
            + " WHERE "
            + NAME_FIELD
            + " = ?";
    String NAME_QUERY =
        "SELECT "
            + NAME_FIELD
            + " FROM "
            + TABLE
            + " WHERE "
            + NAME_FIELD
            + " = ?";
    String DOCUMENT_QUERY =
        "SELECT "
            + LINK_FIELD
            + " FROM "
            + TABLE
            + " WHERE "
            + NAME_FIELD
            + " = ?";
}
